/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.connector.nop;

import org.apache.log4j.Logger;

import tools.descartes.dql.connector.ConnectorProvider;
import tools.descartes.dql.connector.ModelStructureQueryConnector;
import tools.descartes.dql.connector.PerformanceIssueQueryConnector;
import tools.descartes.dql.connector.PerformanceMetricsQueryConnector;
import tools.descartes.dql.core.engine.util.DQLLogger;

public class ConnectorProviderImpl implements ConnectorProvider {
	private final Logger log = DQLLogger.getLogger(this.getClass().getName());

	@Override
	public ModelStructureQueryConnector createModelStructureQueryConnectorInstance() {
		log.info("Creating a ModelStructureQueryConnector instance");
		return new ModelStructureQueryConnectorImpl();
	}

	@Override
	public PerformanceIssueQueryConnector createPerformanceIssueQueryConnectorInstance() {
		log.info("Creating a PerformanceIssueQueryConnector instance");
		return null;
	}

	@Override
	public PerformanceMetricsQueryConnector createPerformanceMetricsQueryConnectorInstance() {
		log.info("Creating a PerformanceMetricsQueryConnector instance");
		return new PerformanceMetricsQueryConnectorImpl();
	}
}
