package tools.descartes.dql.connector.nop;

import java.math.BigDecimal;

import tools.descartes.dql.models.mapping.domain.AbstractSeriesResult;
import tools.descartes.dql.models.mapping.domain.ConfidenceInterval;
import tools.descartes.dql.models.mapping.domain.DomainFactory;
import tools.descartes.dql.models.mapping.domain.SeriesResultElement;

public class OnlineSeriesUpdateThread extends Thread {

	private AbstractSeriesResult seriesResult;
	private int maxNumberOfResults;
	private int tickrateInMillis;

	public OnlineSeriesUpdateThread(AbstractSeriesResult seriesResult, 
			int maxNumberOfResults, int tickrateInMillis) {
		this.seriesResult = seriesResult;
		this.maxNumberOfResults = maxNumberOfResults;
		this.tickrateInMillis = tickrateInMillis;
	}

	public void run() {
		for (int i = 0; i < maxNumberOfResults; i++) {
			SeriesResultElement newElem = DomainFactory.eINSTANCE.createSeriesResultElement();
			newElem.setX(BigDecimal.valueOf(i));
			newElem.setY(BigDecimal.valueOf(2 * Math.pow(i, 2.0) + 3 * i));
			ConfidenceInterval ci = DomainFactory.eINSTANCE.createConfidenceInterval();
			ci.setAccuracy(BigDecimal.valueOf(0.95));
			ci.setIntervalHalfLength(BigDecimal.valueOf(0.2));
			newElem.setConfidenceInterval(ci);
			seriesResult.getElements().add(newElem);
			sleep();
		}
	}

	private void sleep() {
		try {
			Thread.sleep(tickrateInMillis);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}

}
