/**
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage
 * @generated
 */
public interface DescartesQLFactory extends EFactory
{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  DescartesQLFactory eINSTANCE = tools.descartes.dql.lang.descartesQL.impl.DescartesQLFactoryImpl.init();

  /**
   * Returns a new object of class '<em>Descartes QL</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Descartes QL</em>'.
   * @generated
   */
  DescartesQL createDescartesQL();

  /**
   * Returns a new object of class '<em>Model Structure Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Model Structure Query</em>'.
   * @generated
   */
  ModelStructureQuery createModelStructureQuery();

  /**
   * Returns a new object of class '<em>Performance Metrics Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Performance Metrics Query</em>'.
   * @generated
   */
  PerformanceMetricsQuery createPerformanceMetricsQuery();

  /**
   * Returns a new object of class '<em>Performance Issue Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Performance Issue Query</em>'.
   * @generated
   */
  PerformanceIssueQuery createPerformanceIssueQuery();

  /**
   * Returns a new object of class '<em>Connector Capability Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Connector Capability Query</em>'.
   * @generated
   */
  ConnectorCapabilityQuery createConnectorCapabilityQuery();

  /**
   * Returns a new object of class '<em>List Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>List Query</em>'.
   * @generated
   */
  ListQuery createListQuery();

  /**
   * Returns a new object of class '<em>Get Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Get Query</em>'.
   * @generated
   */
  GetQuery createGetQuery();

  /**
   * Returns a new object of class '<em>Get Constraints Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Get Constraints Query</em>'.
   * @generated
   */
  GetConstraintsQuery createGetConstraintsQuery();

  /**
   * Returns a new object of class '<em>Get Exploration Strategies Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Get Exploration Strategies Query</em>'.
   * @generated
   */
  GetExplorationStrategiesQuery createGetExplorationStrategiesQuery();

  /**
   * Returns a new object of class '<em>Get Time Units Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Get Time Units Query</em>'.
   * @generated
   */
  GetTimeUnitsQuery createGetTimeUnitsQuery();

  /**
   * Returns a new object of class '<em>List Do FQuery</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>List Do FQuery</em>'.
   * @generated
   */
  ListDoFQuery createListDoFQuery();

  /**
   * Returns a new object of class '<em>List Entities Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>List Entities Query</em>'.
   * @generated
   */
  ListEntitiesQuery createListEntitiesQuery();

  /**
   * Returns a new object of class '<em>List Resources Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>List Resources Query</em>'.
   * @generated
   */
  ListResourcesQuery createListResourcesQuery();

  /**
   * Returns a new object of class '<em>List Services Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>List Services Query</em>'.
   * @generated
   */
  ListServicesQuery createListServicesQuery();

  /**
   * Returns a new object of class '<em>List Metrics Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>List Metrics Query</em>'.
   * @generated
   */
  ListMetricsQuery createListMetricsQuery();

  /**
   * Returns a new object of class '<em>Select Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Select Query</em>'.
   * @generated
   */
  SelectQuery createSelectQuery();

  /**
   * Returns a new object of class '<em>Metric Reference Clauses</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Metric Reference Clauses</em>'.
   * @generated
   */
  MetricReferenceClauses createMetricReferenceClauses();

  /**
   * Returns a new object of class '<em>Metric Clause Type</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Metric Clause Type</em>'.
   * @generated
   */
  MetricClauseType createMetricClauseType();

  /**
   * Returns a new object of class '<em>Detect Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Detect Query</em>'.
   * @generated
   */
  DetectQuery createDetectQuery();

  /**
   * Returns a new object of class '<em>Detect Bottlenecks Query</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Detect Bottlenecks Query</em>'.
   * @generated
   */
  DetectBottlenecksQuery createDetectBottlenecksQuery();

  /**
   * Returns a new object of class '<em>Constraint Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Constraint Clause</em>'.
   * @generated
   */
  ConstraintClause createConstraintClause();

  /**
   * Returns a new object of class '<em>Do FClause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Do FClause</em>'.
   * @generated
   */
  DoFClause createDoFClause();

  /**
   * Returns a new object of class '<em>Exploration Strategy Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Exploration Strategy Clause</em>'.
   * @generated
   */
  ExplorationStrategyClause createExplorationStrategyClause();

  /**
   * Returns a new object of class '<em>Configuration Properties Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Configuration Properties Clause</em>'.
   * @generated
   */
  ConfigurationPropertiesClause createConfigurationPropertiesClause();

  /**
   * Returns a new object of class '<em>Configuration Property Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Configuration Property Clause</em>'.
   * @generated
   */
  ConfigurationPropertyClause createConfigurationPropertyClause();

  /**
   * Returns a new object of class '<em>Do FVariation Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Do FVariation Clause</em>'.
   * @generated
   */
  DoFVariationClause createDoFVariationClause();

  /**
   * Returns a new object of class '<em>Value Variation Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Value Variation Clause</em>'.
   * @generated
   */
  ValueVariationClause createValueVariationClause();

  /**
   * Returns a new object of class '<em>Interval Variation Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Interval Variation Clause</em>'.
   * @generated
   */
  IntervalVariationClause createIntervalVariationClause();

  /**
   * Returns a new object of class '<em>Varying Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Varying Clause</em>'.
   * @generated
   */
  VaryingClause createVaryingClause();

  /**
   * Returns a new object of class '<em>Do FReference</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Do FReference</em>'.
   * @generated
   */
  DoFReference createDoFReference();

  /**
   * Returns a new object of class '<em>Metric Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Metric Clause</em>'.
   * @generated
   */
  MetricClause createMetricClause();

  /**
   * Returns a new object of class '<em>Aggregate Metric Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Aggregate Metric Clause</em>'.
   * @generated
   */
  AggregateMetricClause createAggregateMetricClause();

  /**
   * Returns a new object of class '<em>Metric Clauses</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Metric Clauses</em>'.
   * @generated
   */
  MetricClauses createMetricClauses();

  /**
   * Returns a new object of class '<em>Metric Star Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Metric Star Clause</em>'.
   * @generated
   */
  MetricStarClause createMetricStarClause();

  /**
   * Returns a new object of class '<em>Metric Reference</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Metric Reference</em>'.
   * @generated
   */
  MetricReference createMetricReference();

  /**
   * Returns a new object of class '<em>For Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>For Clause</em>'.
   * @generated
   */
  ForClause createForClause();

  /**
   * Returns a new object of class '<em>Entity Reference Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Entity Reference Clause</em>'.
   * @generated
   */
  EntityReferenceClause createEntityReferenceClause();

  /**
   * Returns a new object of class '<em>Entity Reference</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Entity Reference</em>'.
   * @generated
   */
  EntityReference createEntityReference();

  /**
   * Returns a new object of class '<em>Alias Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Alias Clause</em>'.
   * @generated
   */
  AliasClause createAliasClause();

  /**
   * Returns a new object of class '<em>Using Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Using Clause</em>'.
   * @generated
   */
  UsingClause createUsingClause();

  /**
   * Returns a new object of class '<em>With Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>With Clause</em>'.
   * @generated
   */
  WithClause createWithClause();

  /**
   * Returns a new object of class '<em>Model Reference Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Model Reference Clause</em>'.
   * @generated
   */
  ModelReferenceClause createModelReferenceClause();

  /**
   * Returns a new object of class '<em>Model Family</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Model Family</em>'.
   * @generated
   */
  ModelFamily createModelFamily();

  /**
   * Returns a new object of class '<em>Model Location</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Model Location</em>'.
   * @generated
   */
  ModelLocation createModelLocation();

  /**
   * Returns a new object of class '<em>Filter Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Filter Clause</em>'.
   * @generated
   */
  FilterClause createFilterClause();

  /**
   * Returns a new object of class '<em>Filter Condition Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Filter Condition Clause</em>'.
   * @generated
   */
  FilterConditionClause createFilterConditionClause();

  /**
   * Returns a new object of class '<em>Filter Condition Value</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Filter Condition Value</em>'.
   * @generated
   */
  FilterConditionValue createFilterConditionValue();

  /**
   * Returns a new object of class '<em>Observe Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Observe Clause</em>'.
   * @generated
   */
  ObserveClause createObserveClause();

  /**
   * Returns a new object of class '<em>Observation Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Observation Clause</em>'.
   * @generated
   */
  ObservationClause createObservationClause();

  /**
   * Returns a new object of class '<em>Sample Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Sample Clause</em>'.
   * @generated
   */
  SampleClause createSampleClause();

  /**
   * Returns a new object of class '<em>Connector Time Unit Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Connector Time Unit Clause</em>'.
   * @generated
   */
  ConnectorTimeUnitClause createConnectorTimeUnitClause();

  /**
   * Returns a new object of class '<em>Connector Instance Reference Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Connector Instance Reference Clause</em>'.
   * @generated
   */
  ConnectorInstanceReferenceClause createConnectorInstanceReferenceClause();

  /**
   * Returns a new object of class '<em>Observe Relative Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Observe Relative Clause</em>'.
   * @generated
   */
  ObserveRelativeClause createObserveRelativeClause();

  /**
   * Returns a new object of class '<em>Observe Between Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Observe Between Clause</em>'.
   * @generated
   */
  ObserveBetweenClause createObserveBetweenClause();

  /**
   * Returns a new object of class '<em>Relative Time With Sign Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Relative Time With Sign Clause</em>'.
   * @generated
   */
  RelativeTimeWithSignClause createRelativeTimeWithSignClause();

  /**
   * Returns a new object of class '<em>Between Time Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Between Time Clause</em>'.
   * @generated
   */
  BetweenTimeClause createBetweenTimeClause();

  /**
   * Returns a new object of class '<em>Time Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Time Clause</em>'.
   * @generated
   */
  TimeClause createTimeClause();

  /**
   * Returns a new object of class '<em>Absolute Time Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Absolute Time Clause</em>'.
   * @generated
   */
  AbsoluteTimeClause createAbsoluteTimeClause();

  /**
   * Returns a new object of class '<em>Relative Time Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Relative Time Clause</em>'.
   * @generated
   */
  RelativeTimeClause createRelativeTimeClause();

  /**
   * Returns a new object of class '<em>Relative Time Duration Clause</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Relative Time Duration Clause</em>'.
   * @generated
   */
  RelativeTimeDurationClause createRelativeTimeDurationClause();

  /**
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated
   */
  DescartesQLPackage getDescartesQLPackage();

} //DescartesQLFactory
