/**
 */
package tools.descartes.dql.lang.descartesQL.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import tools.descartes.dql.lang.descartesQL.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage
 * @generated
 */
public class DescartesQLAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static DescartesQLPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DescartesQLAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = DescartesQLPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DescartesQLSwitch<Adapter> modelSwitch =
    new DescartesQLSwitch<Adapter>()
    {
      @Override
      public Adapter caseDescartesQL(DescartesQL object)
      {
        return createDescartesQLAdapter();
      }
      @Override
      public Adapter caseModelStructureQuery(ModelStructureQuery object)
      {
        return createModelStructureQueryAdapter();
      }
      @Override
      public Adapter casePerformanceMetricsQuery(PerformanceMetricsQuery object)
      {
        return createPerformanceMetricsQueryAdapter();
      }
      @Override
      public Adapter casePerformanceIssueQuery(PerformanceIssueQuery object)
      {
        return createPerformanceIssueQueryAdapter();
      }
      @Override
      public Adapter caseConnectorCapabilityQuery(ConnectorCapabilityQuery object)
      {
        return createConnectorCapabilityQueryAdapter();
      }
      @Override
      public Adapter caseListQuery(ListQuery object)
      {
        return createListQueryAdapter();
      }
      @Override
      public Adapter caseGetQuery(GetQuery object)
      {
        return createGetQueryAdapter();
      }
      @Override
      public Adapter caseGetConstraintsQuery(GetConstraintsQuery object)
      {
        return createGetConstraintsQueryAdapter();
      }
      @Override
      public Adapter caseGetExplorationStrategiesQuery(GetExplorationStrategiesQuery object)
      {
        return createGetExplorationStrategiesQueryAdapter();
      }
      @Override
      public Adapter caseGetTimeUnitsQuery(GetTimeUnitsQuery object)
      {
        return createGetTimeUnitsQueryAdapter();
      }
      @Override
      public Adapter caseListDoFQuery(ListDoFQuery object)
      {
        return createListDoFQueryAdapter();
      }
      @Override
      public Adapter caseListEntitiesQuery(ListEntitiesQuery object)
      {
        return createListEntitiesQueryAdapter();
      }
      @Override
      public Adapter caseListResourcesQuery(ListResourcesQuery object)
      {
        return createListResourcesQueryAdapter();
      }
      @Override
      public Adapter caseListServicesQuery(ListServicesQuery object)
      {
        return createListServicesQueryAdapter();
      }
      @Override
      public Adapter caseListMetricsQuery(ListMetricsQuery object)
      {
        return createListMetricsQueryAdapter();
      }
      @Override
      public Adapter caseSelectQuery(SelectQuery object)
      {
        return createSelectQueryAdapter();
      }
      @Override
      public Adapter caseMetricReferenceClauses(MetricReferenceClauses object)
      {
        return createMetricReferenceClausesAdapter();
      }
      @Override
      public Adapter caseMetricClauseType(MetricClauseType object)
      {
        return createMetricClauseTypeAdapter();
      }
      @Override
      public Adapter caseDetectQuery(DetectQuery object)
      {
        return createDetectQueryAdapter();
      }
      @Override
      public Adapter caseDetectBottlenecksQuery(DetectBottlenecksQuery object)
      {
        return createDetectBottlenecksQueryAdapter();
      }
      @Override
      public Adapter caseConstraintClause(ConstraintClause object)
      {
        return createConstraintClauseAdapter();
      }
      @Override
      public Adapter caseDoFClause(DoFClause object)
      {
        return createDoFClauseAdapter();
      }
      @Override
      public Adapter caseExplorationStrategyClause(ExplorationStrategyClause object)
      {
        return createExplorationStrategyClauseAdapter();
      }
      @Override
      public Adapter caseConfigurationPropertiesClause(ConfigurationPropertiesClause object)
      {
        return createConfigurationPropertiesClauseAdapter();
      }
      @Override
      public Adapter caseConfigurationPropertyClause(ConfigurationPropertyClause object)
      {
        return createConfigurationPropertyClauseAdapter();
      }
      @Override
      public Adapter caseDoFVariationClause(DoFVariationClause object)
      {
        return createDoFVariationClauseAdapter();
      }
      @Override
      public Adapter caseValueVariationClause(ValueVariationClause object)
      {
        return createValueVariationClauseAdapter();
      }
      @Override
      public Adapter caseIntervalVariationClause(IntervalVariationClause object)
      {
        return createIntervalVariationClauseAdapter();
      }
      @Override
      public Adapter caseVaryingClause(VaryingClause object)
      {
        return createVaryingClauseAdapter();
      }
      @Override
      public Adapter caseDoFReference(DoFReference object)
      {
        return createDoFReferenceAdapter();
      }
      @Override
      public Adapter caseMetricClause(MetricClause object)
      {
        return createMetricClauseAdapter();
      }
      @Override
      public Adapter caseAggregateMetricClause(AggregateMetricClause object)
      {
        return createAggregateMetricClauseAdapter();
      }
      @Override
      public Adapter caseMetricClauses(MetricClauses object)
      {
        return createMetricClausesAdapter();
      }
      @Override
      public Adapter caseMetricStarClause(MetricStarClause object)
      {
        return createMetricStarClauseAdapter();
      }
      @Override
      public Adapter caseMetricReference(MetricReference object)
      {
        return createMetricReferenceAdapter();
      }
      @Override
      public Adapter caseForClause(ForClause object)
      {
        return createForClauseAdapter();
      }
      @Override
      public Adapter caseEntityReferenceClause(EntityReferenceClause object)
      {
        return createEntityReferenceClauseAdapter();
      }
      @Override
      public Adapter caseEntityReference(EntityReference object)
      {
        return createEntityReferenceAdapter();
      }
      @Override
      public Adapter caseAliasClause(AliasClause object)
      {
        return createAliasClauseAdapter();
      }
      @Override
      public Adapter caseUsingClause(UsingClause object)
      {
        return createUsingClauseAdapter();
      }
      @Override
      public Adapter caseWithClause(WithClause object)
      {
        return createWithClauseAdapter();
      }
      @Override
      public Adapter caseModelReferenceClause(ModelReferenceClause object)
      {
        return createModelReferenceClauseAdapter();
      }
      @Override
      public Adapter caseModelFamily(ModelFamily object)
      {
        return createModelFamilyAdapter();
      }
      @Override
      public Adapter caseModelLocation(ModelLocation object)
      {
        return createModelLocationAdapter();
      }
      @Override
      public Adapter caseFilterClause(FilterClause object)
      {
        return createFilterClauseAdapter();
      }
      @Override
      public Adapter caseFilterConditionClause(FilterConditionClause object)
      {
        return createFilterConditionClauseAdapter();
      }
      @Override
      public Adapter caseFilterConditionValue(FilterConditionValue object)
      {
        return createFilterConditionValueAdapter();
      }
      @Override
      public Adapter caseObserveClause(ObserveClause object)
      {
        return createObserveClauseAdapter();
      }
      @Override
      public Adapter caseObservationClause(ObservationClause object)
      {
        return createObservationClauseAdapter();
      }
      @Override
      public Adapter caseSampleClause(SampleClause object)
      {
        return createSampleClauseAdapter();
      }
      @Override
      public Adapter caseConnectorTimeUnitClause(ConnectorTimeUnitClause object)
      {
        return createConnectorTimeUnitClauseAdapter();
      }
      @Override
      public Adapter caseConnectorInstanceReferenceClause(ConnectorInstanceReferenceClause object)
      {
        return createConnectorInstanceReferenceClauseAdapter();
      }
      @Override
      public Adapter caseObserveRelativeClause(ObserveRelativeClause object)
      {
        return createObserveRelativeClauseAdapter();
      }
      @Override
      public Adapter caseObserveBetweenClause(ObserveBetweenClause object)
      {
        return createObserveBetweenClauseAdapter();
      }
      @Override
      public Adapter caseRelativeTimeWithSignClause(RelativeTimeWithSignClause object)
      {
        return createRelativeTimeWithSignClauseAdapter();
      }
      @Override
      public Adapter caseBetweenTimeClause(BetweenTimeClause object)
      {
        return createBetweenTimeClauseAdapter();
      }
      @Override
      public Adapter caseTimeClause(TimeClause object)
      {
        return createTimeClauseAdapter();
      }
      @Override
      public Adapter caseAbsoluteTimeClause(AbsoluteTimeClause object)
      {
        return createAbsoluteTimeClauseAdapter();
      }
      @Override
      public Adapter caseRelativeTimeClause(RelativeTimeClause object)
      {
        return createRelativeTimeClauseAdapter();
      }
      @Override
      public Adapter caseRelativeTimeDurationClause(RelativeTimeDurationClause object)
      {
        return createRelativeTimeDurationClauseAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.DescartesQL <em>Descartes QL</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.DescartesQL
   * @generated
   */
  public Adapter createDescartesQLAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ModelStructureQuery <em>Model Structure Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ModelStructureQuery
   * @generated
   */
  public Adapter createModelStructureQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.PerformanceMetricsQuery <em>Performance Metrics Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.PerformanceMetricsQuery
   * @generated
   */
  public Adapter createPerformanceMetricsQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.PerformanceIssueQuery <em>Performance Issue Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.PerformanceIssueQuery
   * @generated
   */
  public Adapter createPerformanceIssueQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ConnectorCapabilityQuery <em>Connector Capability Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorCapabilityQuery
   * @generated
   */
  public Adapter createConnectorCapabilityQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ListQuery <em>List Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ListQuery
   * @generated
   */
  public Adapter createListQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.GetQuery <em>Get Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.GetQuery
   * @generated
   */
  public Adapter createGetQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.GetConstraintsQuery <em>Get Constraints Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.GetConstraintsQuery
   * @generated
   */
  public Adapter createGetConstraintsQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.GetExplorationStrategiesQuery <em>Get Exploration Strategies Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.GetExplorationStrategiesQuery
   * @generated
   */
  public Adapter createGetExplorationStrategiesQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.GetTimeUnitsQuery <em>Get Time Units Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.GetTimeUnitsQuery
   * @generated
   */
  public Adapter createGetTimeUnitsQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ListDoFQuery <em>List Do FQuery</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ListDoFQuery
   * @generated
   */
  public Adapter createListDoFQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ListEntitiesQuery <em>List Entities Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ListEntitiesQuery
   * @generated
   */
  public Adapter createListEntitiesQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ListResourcesQuery <em>List Resources Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ListResourcesQuery
   * @generated
   */
  public Adapter createListResourcesQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ListServicesQuery <em>List Services Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ListServicesQuery
   * @generated
   */
  public Adapter createListServicesQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ListMetricsQuery <em>List Metrics Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ListMetricsQuery
   * @generated
   */
  public Adapter createListMetricsQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.SelectQuery <em>Select Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.SelectQuery
   * @generated
   */
  public Adapter createSelectQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.MetricReferenceClauses <em>Metric Reference Clauses</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.MetricReferenceClauses
   * @generated
   */
  public Adapter createMetricReferenceClausesAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.MetricClauseType <em>Metric Clause Type</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.MetricClauseType
   * @generated
   */
  public Adapter createMetricClauseTypeAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.DetectQuery <em>Detect Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.DetectQuery
   * @generated
   */
  public Adapter createDetectQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.DetectBottlenecksQuery <em>Detect Bottlenecks Query</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.DetectBottlenecksQuery
   * @generated
   */
  public Adapter createDetectBottlenecksQueryAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ConstraintClause <em>Constraint Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ConstraintClause
   * @generated
   */
  public Adapter createConstraintClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.DoFClause <em>Do FClause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.DoFClause
   * @generated
   */
  public Adapter createDoFClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause <em>Exploration Strategy Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ExplorationStrategyClause
   * @generated
   */
  public Adapter createExplorationStrategyClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause <em>Configuration Properties Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause
   * @generated
   */
  public Adapter createConfigurationPropertiesClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause <em>Configuration Property Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ConfigurationPropertyClause
   * @generated
   */
  public Adapter createConfigurationPropertyClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.DoFVariationClause <em>Do FVariation Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.DoFVariationClause
   * @generated
   */
  public Adapter createDoFVariationClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ValueVariationClause <em>Value Variation Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ValueVariationClause
   * @generated
   */
  public Adapter createValueVariationClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.IntervalVariationClause <em>Interval Variation Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.IntervalVariationClause
   * @generated
   */
  public Adapter createIntervalVariationClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.VaryingClause <em>Varying Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.VaryingClause
   * @generated
   */
  public Adapter createVaryingClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.DoFReference <em>Do FReference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.DoFReference
   * @generated
   */
  public Adapter createDoFReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.MetricClause <em>Metric Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.MetricClause
   * @generated
   */
  public Adapter createMetricClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause <em>Aggregate Metric Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.AggregateMetricClause
   * @generated
   */
  public Adapter createAggregateMetricClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.MetricClauses <em>Metric Clauses</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.MetricClauses
   * @generated
   */
  public Adapter createMetricClausesAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.MetricStarClause <em>Metric Star Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.MetricStarClause
   * @generated
   */
  public Adapter createMetricStarClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.MetricReference <em>Metric Reference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.MetricReference
   * @generated
   */
  public Adapter createMetricReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ForClause <em>For Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ForClause
   * @generated
   */
  public Adapter createForClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.EntityReferenceClause <em>Entity Reference Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.EntityReferenceClause
   * @generated
   */
  public Adapter createEntityReferenceClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.EntityReference <em>Entity Reference</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.EntityReference
   * @generated
   */
  public Adapter createEntityReferenceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.AliasClause <em>Alias Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.AliasClause
   * @generated
   */
  public Adapter createAliasClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.UsingClause <em>Using Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.UsingClause
   * @generated
   */
  public Adapter createUsingClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.WithClause <em>With Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.WithClause
   * @generated
   */
  public Adapter createWithClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ModelReferenceClause <em>Model Reference Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ModelReferenceClause
   * @generated
   */
  public Adapter createModelReferenceClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ModelFamily <em>Model Family</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ModelFamily
   * @generated
   */
  public Adapter createModelFamilyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ModelLocation <em>Model Location</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ModelLocation
   * @generated
   */
  public Adapter createModelLocationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.FilterClause <em>Filter Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.FilterClause
   * @generated
   */
  public Adapter createFilterClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.FilterConditionClause <em>Filter Condition Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionClause
   * @generated
   */
  public Adapter createFilterConditionClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.FilterConditionValue <em>Filter Condition Value</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.FilterConditionValue
   * @generated
   */
  public Adapter createFilterConditionValueAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ObserveClause <em>Observe Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ObserveClause
   * @generated
   */
  public Adapter createObserveClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ObservationClause <em>Observation Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ObservationClause
   * @generated
   */
  public Adapter createObservationClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.SampleClause <em>Sample Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.SampleClause
   * @generated
   */
  public Adapter createSampleClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause <em>Connector Time Unit Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause
   * @generated
   */
  public Adapter createConnectorTimeUnitClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ConnectorInstanceReferenceClause <em>Connector Instance Reference Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ConnectorInstanceReferenceClause
   * @generated
   */
  public Adapter createConnectorInstanceReferenceClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ObserveRelativeClause <em>Observe Relative Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ObserveRelativeClause
   * @generated
   */
  public Adapter createObserveRelativeClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause <em>Observe Between Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.ObserveBetweenClause
   * @generated
   */
  public Adapter createObserveBetweenClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause <em>Relative Time With Sign Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause
   * @generated
   */
  public Adapter createRelativeTimeWithSignClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.BetweenTimeClause <em>Between Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.BetweenTimeClause
   * @generated
   */
  public Adapter createBetweenTimeClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.TimeClause <em>Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.TimeClause
   * @generated
   */
  public Adapter createTimeClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.AbsoluteTimeClause <em>Absolute Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.AbsoluteTimeClause
   * @generated
   */
  public Adapter createAbsoluteTimeClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeClause <em>Relative Time Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeClause
   * @generated
   */
  public Adapter createRelativeTimeClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause <em>Relative Time Duration Clause</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause
   * @generated
   */
  public Adapter createRelativeTimeDurationClauseAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //DescartesQLAdapterFactory
