/**
 */
package tools.descartes.dql.models.mapping.domain.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import tools.descartes.dql.models.mapping.domain.util.DomainAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class DomainItemProviderAdapterFactory extends DomainAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DomainItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.Resource} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResourceItemProvider resourceItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.Resource}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createResourceAdapter() {
		if (resourceItemProvider == null) {
			resourceItemProvider = new ResourceItemProvider(this);
		}

		return resourceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.Service} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ServiceItemProvider serviceItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.Service}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createServiceAdapter() {
		if (serviceItemProvider == null) {
			serviceItemProvider = new ServiceItemProvider(this);
		}

		return serviceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.Probe} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProbeItemProvider probeItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.Probe}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProbeAdapter() {
		if (probeItemProvider == null) {
			probeItemProvider = new ProbeItemProvider(this);
		}

		return probeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.DecimalResult} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DecimalResultItemProvider decimalResultItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.DecimalResult}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDecimalResultAdapter() {
		if (decimalResultItemProvider == null) {
			decimalResultItemProvider = new DecimalResultItemProvider(this);
		}

		return decimalResultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.DoF} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DoFItemProvider doFItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.DoF}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDoFAdapter() {
		if (doFItemProvider == null) {
			doFItemProvider = new DoFItemProvider(this);
		}

		return doFItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.Aggregate} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AggregateItemProvider aggregateItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.Aggregate}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAggregateAdapter() {
		if (aggregateItemProvider == null) {
			aggregateItemProvider = new AggregateItemProvider(this);
		}

		return aggregateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.StringResult} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StringResultItemProvider stringResultItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.StringResult}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStringResultAdapter() {
		if (stringResultItemProvider == null) {
			stringResultItemProvider = new StringResultItemProvider(this);
		}

		return stringResultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.SeriesResultElement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SeriesResultElementItemProvider seriesResultElementItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.SeriesResultElement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSeriesResultElementAdapter() {
		if (seriesResultElementItemProvider == null) {
			seriesResultElementItemProvider = new SeriesResultElementItemProvider(this);
		}

		return seriesResultElementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.ContinuousSeriesResult} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ContinuousSeriesResultItemProvider continuousSeriesResultItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.ContinuousSeriesResult}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createContinuousSeriesResultAdapter() {
		if (continuousSeriesResultItemProvider == null) {
			continuousSeriesResultItemProvider = new ContinuousSeriesResultItemProvider(this);
		}

		return continuousSeriesResultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.DiscreteSeriesResult} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DiscreteSeriesResultItemProvider discreteSeriesResultItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.DiscreteSeriesResult}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDiscreteSeriesResultAdapter() {
		if (discreteSeriesResultItemProvider == null) {
			discreteSeriesResultItemProvider = new DiscreteSeriesResultItemProvider(this);
		}

		return discreteSeriesResultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConfidenceIntervalItemProvider confidenceIntervalItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConfidenceIntervalAdapter() {
		if (confidenceIntervalItemProvider == null) {
			confidenceIntervalItemProvider = new ConfidenceIntervalItemProvider(this);
		}

		return confidenceIntervalItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.ResultList} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResultListItemProvider resultListItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.ResultList}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createResultListAdapter() {
		if (resultListItemProvider == null) {
			resultListItemProvider = new ResultListItemProvider(this);
		}

		return resultListItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.OnlineResult} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OnlineResultItemProvider onlineResultItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.OnlineResult}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOnlineResultAdapter() {
		if (onlineResultItemProvider == null) {
			onlineResultItemProvider = new OnlineResultItemProvider(this);
		}

		return onlineResultItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dql.models.mapping.domain.StatType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StatTypeItemProvider statTypeItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dql.models.mapping.domain.StatType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStatTypeAdapter() {
		if (statTypeItemProvider == null) {
			statTypeItemProvider = new StatTypeItemProvider(this);
		}

		return statTypeItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (resourceItemProvider != null) resourceItemProvider.dispose();
		if (serviceItemProvider != null) serviceItemProvider.dispose();
		if (probeItemProvider != null) probeItemProvider.dispose();
		if (decimalResultItemProvider != null) decimalResultItemProvider.dispose();
		if (doFItemProvider != null) doFItemProvider.dispose();
		if (aggregateItemProvider != null) aggregateItemProvider.dispose();
		if (stringResultItemProvider != null) stringResultItemProvider.dispose();
		if (seriesResultElementItemProvider != null) seriesResultElementItemProvider.dispose();
		if (continuousSeriesResultItemProvider != null) continuousSeriesResultItemProvider.dispose();
		if (discreteSeriesResultItemProvider != null) discreteSeriesResultItemProvider.dispose();
		if (confidenceIntervalItemProvider != null) confidenceIntervalItemProvider.dispose();
		if (resultListItemProvider != null) resultListItemProvider.dispose();
		if (onlineResultItemProvider != null) onlineResultItemProvider.dispose();
		if (statTypeItemProvider != null) statTypeItemProvider.dispose();
	}

}
