/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.domain;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dql.models.mapping.domain.DomainFactory
 * @model kind="package"
 * @generated
 */
public interface DomainPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "domain";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/dql/models/mapping/domain/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "domain";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DomainPackage eINSTANCE = tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.EntityImpl <em>Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.EntityImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getEntity()
	 * @generated
	 */
	int ENTITY = 2;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__IDENTIFIER = 0;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__ALIAS = 1;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__PROBES = 2;

	/**
	 * The number of structural features of the '<em>Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResourceImpl <em>Resource</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ResourceImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResource()
	 * @generated
	 */
	int RESOURCE = 0;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__IDENTIFIER = ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__ALIAS = ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE__PROBES = ENTITY__PROBES;

	/**
	 * The number of structural features of the '<em>Resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ServiceImpl <em>Service</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ServiceImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getService()
	 * @generated
	 */
	int SERVICE = 1;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__IDENTIFIER = ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__ALIAS = ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE__PROBES = ENTITY__PROBES;

	/**
	 * The number of structural features of the '<em>Service</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERVICE_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ProbeImpl <em>Probe</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ProbeImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getProbe()
	 * @generated
	 */
	int PROBE = 3;

	/**
	 * The feature id for the '<em><b>Metric Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBE__METRIC_NAME = 0;

	/**
	 * The feature id for the '<em><b>Stat Types</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBE__STAT_TYPES = 1;

	/**
	 * The number of structural features of the '<em>Probe</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResultImpl <em>Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResult()
	 * @generated
	 */
	int RESULT = 5;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT__VALID = 0;

	/**
	 * The number of structural features of the '<em>Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.DecimalResultImpl <em>Decimal Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.DecimalResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDecimalResult()
	 * @generated
	 */
	int DECIMAL_RESULT = 4;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT__VALID = RESULT__VALID;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT__VALUE = RESULT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Confidence Interval</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT__CONFIDENCE_INTERVAL = RESULT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Decimal Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECIMAL_RESULT_FEATURE_COUNT = RESULT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ExtendedEntityImpl <em>Extended Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ExtendedEntityImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getExtendedEntity()
	 * @generated
	 */
	int EXTENDED_ENTITY = 8;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY__IDENTIFIER = ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY__ALIAS = ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY__PROBES = ENTITY__PROBES;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY__PROPERTIES = ENTITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Extended Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTENDED_ENTITY_FEATURE_COUNT = ENTITY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.DoFImpl <em>Do F</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.DoFImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDoF()
	 * @generated
	 */
	int DO_F = 6;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__IDENTIFIER = EXTENDED_ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__ALIAS = EXTENDED_ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__PROBES = EXTENDED_ENTITY__PROBES;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F__PROPERTIES = EXTENDED_ENTITY__PROPERTIES;

	/**
	 * The number of structural features of the '<em>Do F</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DO_F_FEATURE_COUNT = EXTENDED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.AggregateImpl <em>Aggregate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.AggregateImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getAggregate()
	 * @generated
	 */
	int AGGREGATE = 7;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE__IDENTIFIER = EXTENDED_ENTITY__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Alias</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE__ALIAS = EXTENDED_ENTITY__ALIAS;

	/**
	 * The feature id for the '<em><b>Probes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE__PROBES = EXTENDED_ENTITY__PROBES;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE__PROPERTIES = EXTENDED_ENTITY__PROPERTIES;

	/**
	 * The number of structural features of the '<em>Aggregate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AGGREGATE_FEATURE_COUNT = EXTENDED_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.StringResultImpl <em>String Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.StringResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getStringResult()
	 * @generated
	 */
	int STRING_RESULT = 9;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_RESULT__VALID = RESULT__VALID;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_RESULT__VALUE = RESULT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>String Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_RESULT_FEATURE_COUNT = RESULT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.AbstractSeriesResultImpl <em>Abstract Series Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.AbstractSeriesResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getAbstractSeriesResult()
	 * @generated
	 */
	int ABSTRACT_SERIES_RESULT = 10;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SERIES_RESULT__VALID = RESULT__VALID;

	/**
	 * The feature id for the '<em><b>XAxis Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION = RESULT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>YAxis Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION = RESULT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SERIES_RESULT__ELEMENTS = RESULT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Abstract Series Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_SERIES_RESULT_FEATURE_COUNT = RESULT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.SeriesResultElementImpl <em>Series Result Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.SeriesResultElementImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getSeriesResultElement()
	 * @generated
	 */
	int SERIES_RESULT_ELEMENT = 11;

	/**
	 * The feature id for the '<em><b>X</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERIES_RESULT_ELEMENT__X = 0;

	/**
	 * The feature id for the '<em><b>Y</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERIES_RESULT_ELEMENT__Y = 1;

	/**
	 * The feature id for the '<em><b>Confidence Interval</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERIES_RESULT_ELEMENT__CONFIDENCE_INTERVAL = 2;

	/**
	 * The number of structural features of the '<em>Series Result Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SERIES_RESULT_ELEMENT_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ContinuousSeriesResultImpl <em>Continuous Series Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ContinuousSeriesResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getContinuousSeriesResult()
	 * @generated
	 */
	int CONTINUOUS_SERIES_RESULT = 12;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_SERIES_RESULT__VALID = ABSTRACT_SERIES_RESULT__VALID;

	/**
	 * The feature id for the '<em><b>XAxis Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_SERIES_RESULT__XAXIS_DESCRIPTION = ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>YAxis Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_SERIES_RESULT__YAXIS_DESCRIPTION = ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_SERIES_RESULT__ELEMENTS = ABSTRACT_SERIES_RESULT__ELEMENTS;

	/**
	 * The number of structural features of the '<em>Continuous Series Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTINUOUS_SERIES_RESULT_FEATURE_COUNT = ABSTRACT_SERIES_RESULT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.DiscreteSeriesResultImpl <em>Discrete Series Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.DiscreteSeriesResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDiscreteSeriesResult()
	 * @generated
	 */
	int DISCRETE_SERIES_RESULT = 13;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_SERIES_RESULT__VALID = ABSTRACT_SERIES_RESULT__VALID;

	/**
	 * The feature id for the '<em><b>XAxis Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_SERIES_RESULT__XAXIS_DESCRIPTION = ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>YAxis Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_SERIES_RESULT__YAXIS_DESCRIPTION = ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Elements</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_SERIES_RESULT__ELEMENTS = ABSTRACT_SERIES_RESULT__ELEMENTS;

	/**
	 * The number of structural features of the '<em>Discrete Series Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_SERIES_RESULT_FEATURE_COUNT = ABSTRACT_SERIES_RESULT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ConfidenceIntervalImpl <em>Confidence Interval</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ConfidenceIntervalImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getConfidenceInterval()
	 * @generated
	 */
	int CONFIDENCE_INTERVAL = 14;

	/**
	 * The feature id for the '<em><b>Accuracy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONFIDENCE_INTERVAL__ACCURACY = 0;

	/**
	 * The feature id for the '<em><b>Interval Half Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONFIDENCE_INTERVAL__INTERVAL_HALF_LENGTH = 1;

	/**
	 * The number of structural features of the '<em>Confidence Interval</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONFIDENCE_INTERVAL_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResultListImpl <em>Result List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.ResultListImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResultList()
	 * @generated
	 */
	int RESULT_LIST = 15;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_LIST__VALID = RESULT__VALID;

	/**
	 * The feature id for the '<em><b>Results</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_LIST__RESULTS = RESULT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Result List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESULT_LIST_FEATURE_COUNT = RESULT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.OnlineResultImpl <em>Online Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.OnlineResultImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getOnlineResult()
	 * @generated
	 */
	int ONLINE_RESULT = 16;

	/**
	 * The feature id for the '<em><b>Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONLINE_RESULT__VALID = RESULT__VALID;

	/**
	 * The feature id for the '<em><b>Result</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONLINE_RESULT__RESULT = RESULT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Online Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ONLINE_RESULT_FEATURE_COUNT = RESULT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.domain.impl.StatTypeImpl <em>Stat Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.domain.impl.StatTypeImpl
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getStatType()
	 * @generated
	 */
	int STAT_TYPE = 17;

	/**
	 * The feature id for the '<em><b>Type Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAT_TYPE__TYPE_NAME = 0;

	/**
	 * The feature id for the '<em><b>Result</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAT_TYPE__RESULT = 1;

	/**
	 * The number of structural features of the '<em>Stat Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STAT_TYPE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '<em>Properties</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.util.Properties
	 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getProperties()
	 * @generated
	 */
	int PROPERTIES = 18;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Resource <em>Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resource</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Resource
	 * @generated
	 */
	EClass getResource();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Service <em>Service</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Service</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Service
	 * @generated
	 */
	EClass getService();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Entity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Entity
	 * @generated
	 */
	EClass getEntity();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.Entity#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Identifier</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Entity#getIdentifier()
	 * @see #getEntity()
	 * @generated
	 */
	EAttribute getEntity_Identifier();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.Entity#getAlias <em>Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alias</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Entity#getAlias()
	 * @see #getEntity()
	 * @generated
	 */
	EAttribute getEntity_Alias();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dql.models.mapping.domain.Entity#getProbes <em>Probes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Probes</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Entity#getProbes()
	 * @see #getEntity()
	 * @generated
	 */
	EReference getEntity_Probes();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Probe <em>Probe</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Probe</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Probe
	 * @generated
	 */
	EClass getProbe();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.Probe#getMetricName <em>Metric Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Metric Name</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Probe#getMetricName()
	 * @see #getProbe()
	 * @generated
	 */
	EAttribute getProbe_MetricName();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dql.models.mapping.domain.Probe#getStatTypes <em>Stat Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Stat Types</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Probe#getStatTypes()
	 * @see #getProbe()
	 * @generated
	 */
	EReference getProbe_StatTypes();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.DecimalResult <em>Decimal Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Decimal Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DecimalResult
	 * @generated
	 */
	EClass getDecimalResult();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.DecimalResult#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DecimalResult#getValue()
	 * @see #getDecimalResult()
	 * @generated
	 */
	EAttribute getDecimalResult_Value();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.mapping.domain.DecimalResult#getConfidenceInterval <em>Confidence Interval</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Confidence Interval</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DecimalResult#getConfidenceInterval()
	 * @see #getDecimalResult()
	 * @generated
	 */
	EReference getDecimalResult_ConfidenceInterval();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Result <em>Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Result
	 * @generated
	 */
	EClass getResult();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.Result#getValid <em>Valid</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Valid</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Result#getValid()
	 * @see #getResult()
	 * @generated
	 */
	EAttribute getResult_Valid();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.DoF <em>Do F</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Do F</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DoF
	 * @generated
	 */
	EClass getDoF();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.Aggregate <em>Aggregate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Aggregate</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.Aggregate
	 * @generated
	 */
	EClass getAggregate();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.ExtendedEntity <em>Extended Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Extended Entity</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ExtendedEntity
	 * @generated
	 */
	EClass getExtendedEntity();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.ExtendedEntity#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Properties</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ExtendedEntity#getProperties()
	 * @see #getExtendedEntity()
	 * @generated
	 */
	EAttribute getExtendedEntity_Properties();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.StringResult <em>String Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>String Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.StringResult
	 * @generated
	 */
	EClass getStringResult();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.StringResult#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.StringResult#getValue()
	 * @see #getStringResult()
	 * @generated
	 */
	EAttribute getStringResult_Value();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.AbstractSeriesResult <em>Abstract Series Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Series Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.AbstractSeriesResult
	 * @generated
	 */
	EClass getAbstractSeriesResult();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.AbstractSeriesResult#getXAxisDescription <em>XAxis Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>XAxis Description</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.AbstractSeriesResult#getXAxisDescription()
	 * @see #getAbstractSeriesResult()
	 * @generated
	 */
	EAttribute getAbstractSeriesResult_XAxisDescription();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.AbstractSeriesResult#getYAxisDescription <em>YAxis Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>YAxis Description</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.AbstractSeriesResult#getYAxisDescription()
	 * @see #getAbstractSeriesResult()
	 * @generated
	 */
	EAttribute getAbstractSeriesResult_YAxisDescription();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dql.models.mapping.domain.AbstractSeriesResult#getElements <em>Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Elements</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.AbstractSeriesResult#getElements()
	 * @see #getAbstractSeriesResult()
	 * @generated
	 */
	EReference getAbstractSeriesResult_Elements();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.SeriesResultElement <em>Series Result Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Series Result Element</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.SeriesResultElement
	 * @generated
	 */
	EClass getSeriesResultElement();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.SeriesResultElement#getX <em>X</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>X</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.SeriesResultElement#getX()
	 * @see #getSeriesResultElement()
	 * @generated
	 */
	EAttribute getSeriesResultElement_X();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.SeriesResultElement#getY <em>Y</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Y</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.SeriesResultElement#getY()
	 * @see #getSeriesResultElement()
	 * @generated
	 */
	EAttribute getSeriesResultElement_Y();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.mapping.domain.SeriesResultElement#getConfidenceInterval <em>Confidence Interval</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Confidence Interval</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.SeriesResultElement#getConfidenceInterval()
	 * @see #getSeriesResultElement()
	 * @generated
	 */
	EReference getSeriesResultElement_ConfidenceInterval();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.ContinuousSeriesResult <em>Continuous Series Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Continuous Series Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ContinuousSeriesResult
	 * @generated
	 */
	EClass getContinuousSeriesResult();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.DiscreteSeriesResult <em>Discrete Series Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Discrete Series Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.DiscreteSeriesResult
	 * @generated
	 */
	EClass getDiscreteSeriesResult();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval <em>Confidence Interval</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Confidence Interval</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ConfidenceInterval
	 * @generated
	 */
	EClass getConfidenceInterval();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval#getAccuracy <em>Accuracy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Accuracy</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ConfidenceInterval#getAccuracy()
	 * @see #getConfidenceInterval()
	 * @generated
	 */
	EAttribute getConfidenceInterval_Accuracy();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval#getIntervalHalfLength <em>Interval Half Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Interval Half Length</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ConfidenceInterval#getIntervalHalfLength()
	 * @see #getConfidenceInterval()
	 * @generated
	 */
	EAttribute getConfidenceInterval_IntervalHalfLength();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.ResultList <em>Result List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Result List</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ResultList
	 * @generated
	 */
	EClass getResultList();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dql.models.mapping.domain.ResultList#getResults <em>Results</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Results</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.ResultList#getResults()
	 * @see #getResultList()
	 * @generated
	 */
	EReference getResultList_Results();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.OnlineResult <em>Online Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Online Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.OnlineResult
	 * @generated
	 */
	EClass getOnlineResult();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.mapping.domain.OnlineResult#getResult <em>Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.OnlineResult#getResult()
	 * @see #getOnlineResult()
	 * @generated
	 */
	EReference getOnlineResult_Result();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.domain.StatType <em>Stat Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stat Type</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.StatType
	 * @generated
	 */
	EClass getStatType();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.domain.StatType#getTypeName <em>Type Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type Name</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.StatType#getTypeName()
	 * @see #getStatType()
	 * @generated
	 */
	EAttribute getStatType_TypeName();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.mapping.domain.StatType#getResult <em>Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Result</em>'.
	 * @see tools.descartes.dql.models.mapping.domain.StatType#getResult()
	 * @see #getStatType()
	 * @generated
	 */
	EReference getStatType_Result();

	/**
	 * Returns the meta object for data type '{@link java.util.Properties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Properties</em>'.
	 * @see java.util.Properties
	 * @model instanceClass="java.util.Properties"
	 * @generated
	 */
	EDataType getProperties();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	DomainFactory getDomainFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResourceImpl <em>Resource</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ResourceImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResource()
		 * @generated
		 */
		EClass RESOURCE = eINSTANCE.getResource();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ServiceImpl <em>Service</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ServiceImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getService()
		 * @generated
		 */
		EClass SERVICE = eINSTANCE.getService();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.EntityImpl <em>Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.EntityImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getEntity()
		 * @generated
		 */
		EClass ENTITY = eINSTANCE.getEntity();

		/**
		 * The meta object literal for the '<em><b>Identifier</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY__IDENTIFIER = eINSTANCE.getEntity_Identifier();

		/**
		 * The meta object literal for the '<em><b>Alias</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY__ALIAS = eINSTANCE.getEntity_Alias();

		/**
		 * The meta object literal for the '<em><b>Probes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY__PROBES = eINSTANCE.getEntity_Probes();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ProbeImpl <em>Probe</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ProbeImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getProbe()
		 * @generated
		 */
		EClass PROBE = eINSTANCE.getProbe();

		/**
		 * The meta object literal for the '<em><b>Metric Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROBE__METRIC_NAME = eINSTANCE.getProbe_MetricName();

		/**
		 * The meta object literal for the '<em><b>Stat Types</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROBE__STAT_TYPES = eINSTANCE.getProbe_StatTypes();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.DecimalResultImpl <em>Decimal Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.DecimalResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDecimalResult()
		 * @generated
		 */
		EClass DECIMAL_RESULT = eINSTANCE.getDecimalResult();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DECIMAL_RESULT__VALUE = eINSTANCE.getDecimalResult_Value();

		/**
		 * The meta object literal for the '<em><b>Confidence Interval</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DECIMAL_RESULT__CONFIDENCE_INTERVAL = eINSTANCE.getDecimalResult_ConfidenceInterval();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResultImpl <em>Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResult()
		 * @generated
		 */
		EClass RESULT = eINSTANCE.getResult();

		/**
		 * The meta object literal for the '<em><b>Valid</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESULT__VALID = eINSTANCE.getResult_Valid();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.DoFImpl <em>Do F</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.DoFImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDoF()
		 * @generated
		 */
		EClass DO_F = eINSTANCE.getDoF();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.AggregateImpl <em>Aggregate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.AggregateImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getAggregate()
		 * @generated
		 */
		EClass AGGREGATE = eINSTANCE.getAggregate();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ExtendedEntityImpl <em>Extended Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ExtendedEntityImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getExtendedEntity()
		 * @generated
		 */
		EClass EXTENDED_ENTITY = eINSTANCE.getExtendedEntity();

		/**
		 * The meta object literal for the '<em><b>Properties</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXTENDED_ENTITY__PROPERTIES = eINSTANCE.getExtendedEntity_Properties();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.StringResultImpl <em>String Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.StringResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getStringResult()
		 * @generated
		 */
		EClass STRING_RESULT = eINSTANCE.getStringResult();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STRING_RESULT__VALUE = eINSTANCE.getStringResult_Value();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.AbstractSeriesResultImpl <em>Abstract Series Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.AbstractSeriesResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getAbstractSeriesResult()
		 * @generated
		 */
		EClass ABSTRACT_SERIES_RESULT = eINSTANCE.getAbstractSeriesResult();

		/**
		 * The meta object literal for the '<em><b>XAxis Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_SERIES_RESULT__XAXIS_DESCRIPTION = eINSTANCE.getAbstractSeriesResult_XAxisDescription();

		/**
		 * The meta object literal for the '<em><b>YAxis Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ABSTRACT_SERIES_RESULT__YAXIS_DESCRIPTION = eINSTANCE.getAbstractSeriesResult_YAxisDescription();

		/**
		 * The meta object literal for the '<em><b>Elements</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ABSTRACT_SERIES_RESULT__ELEMENTS = eINSTANCE.getAbstractSeriesResult_Elements();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.SeriesResultElementImpl <em>Series Result Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.SeriesResultElementImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getSeriesResultElement()
		 * @generated
		 */
		EClass SERIES_RESULT_ELEMENT = eINSTANCE.getSeriesResultElement();

		/**
		 * The meta object literal for the '<em><b>X</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SERIES_RESULT_ELEMENT__X = eINSTANCE.getSeriesResultElement_X();

		/**
		 * The meta object literal for the '<em><b>Y</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SERIES_RESULT_ELEMENT__Y = eINSTANCE.getSeriesResultElement_Y();

		/**
		 * The meta object literal for the '<em><b>Confidence Interval</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SERIES_RESULT_ELEMENT__CONFIDENCE_INTERVAL = eINSTANCE.getSeriesResultElement_ConfidenceInterval();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ContinuousSeriesResultImpl <em>Continuous Series Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ContinuousSeriesResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getContinuousSeriesResult()
		 * @generated
		 */
		EClass CONTINUOUS_SERIES_RESULT = eINSTANCE.getContinuousSeriesResult();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.DiscreteSeriesResultImpl <em>Discrete Series Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.DiscreteSeriesResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getDiscreteSeriesResult()
		 * @generated
		 */
		EClass DISCRETE_SERIES_RESULT = eINSTANCE.getDiscreteSeriesResult();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ConfidenceIntervalImpl <em>Confidence Interval</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ConfidenceIntervalImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getConfidenceInterval()
		 * @generated
		 */
		EClass CONFIDENCE_INTERVAL = eINSTANCE.getConfidenceInterval();

		/**
		 * The meta object literal for the '<em><b>Accuracy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONFIDENCE_INTERVAL__ACCURACY = eINSTANCE.getConfidenceInterval_Accuracy();

		/**
		 * The meta object literal for the '<em><b>Interval Half Length</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONFIDENCE_INTERVAL__INTERVAL_HALF_LENGTH = eINSTANCE.getConfidenceInterval_IntervalHalfLength();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.ResultListImpl <em>Result List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.ResultListImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getResultList()
		 * @generated
		 */
		EClass RESULT_LIST = eINSTANCE.getResultList();

		/**
		 * The meta object literal for the '<em><b>Results</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESULT_LIST__RESULTS = eINSTANCE.getResultList_Results();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.OnlineResultImpl <em>Online Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.OnlineResultImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getOnlineResult()
		 * @generated
		 */
		EClass ONLINE_RESULT = eINSTANCE.getOnlineResult();

		/**
		 * The meta object literal for the '<em><b>Result</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ONLINE_RESULT__RESULT = eINSTANCE.getOnlineResult_Result();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.domain.impl.StatTypeImpl <em>Stat Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.domain.impl.StatTypeImpl
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getStatType()
		 * @generated
		 */
		EClass STAT_TYPE = eINSTANCE.getStatType();

		/**
		 * The meta object literal for the '<em><b>Type Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STAT_TYPE__TYPE_NAME = eINSTANCE.getStatType_TypeName();

		/**
		 * The meta object literal for the '<em><b>Result</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STAT_TYPE__RESULT = eINSTANCE.getStatType_Result();

		/**
		 * The meta object literal for the '<em>Properties</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.util.Properties
		 * @see tools.descartes.dql.models.mapping.domain.impl.DomainPackageImpl#getProperties()
		 * @generated
		 */
		EDataType PROPERTIES = eINSTANCE.getProperties();

	}

} //DomainPackage
