/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.domain;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Probe</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.Probe#getMetricName <em>Metric Name</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.Probe#getStatTypes <em>Stat Types</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getProbe()
 * @model
 * @generated
 */
public interface Probe extends EObject {
	/**
	 * Returns the value of the '<em><b>Metric Name</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Metric Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Metric Name</em>' attribute.
	 * @see #setMetricName(String)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getProbe_MetricName()
	 * @model default=""
	 * @generated
	 */
	String getMetricName();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.Probe#getMetricName <em>Metric Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Metric Name</em>' attribute.
	 * @see #getMetricName()
	 * @generated
	 */
	void setMetricName(String value);

	/**
	 * Returns the value of the '<em><b>Stat Types</b></em>' reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.mapping.domain.StatType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stat Types</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stat Types</em>' reference list.
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getProbe_StatTypes()
	 * @model
	 * @generated
	 */
	EList<StatType> getStatTypes();

} // Probe
