package tools.descartes.PAVO;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.util.LinkedList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import tools.descartes.PAVO.draw.Visualizer;
import tools.descartes.dql.models.mapping.domain.Entity;
import tools.descartes.dql.models.mapping.mapping.EntityMapping;



public class GraphicsEngine {

	private JFrame mainFrame= new JFrame();
	private EntityMapping currentMapping;
	private JTabbedPane tabbedPane = new JTabbedPane();
	
	
	
	
	
	public GraphicsEngine(String title, EntityMapping mappingNeu) {	

		currentMapping = mappingNeu;
		mainFrame.setTitle(title);
		mainFrame.setBackground(Color.WHITE);
		mainFrame.add(tabbedPane);
		
		interpreteEntityMapping(currentMapping, tabbedPane);
		mainFrame.pack();
		mainFrame.setVisible(true);	
		mainFrame.setResizable(false);
	
	}
	/**
	 * Method to interprete the EntityMapping received by DQL and merges diagrams
	 */
	public static void interpreteEntityMapping(EntityMapping mapping, JTabbedPane tabPane)
	{
		List<Entity> entities = new LinkedList<Entity>();
		entities.addAll(mapping.getResources());
		entities.addAll(mapping.getServices());
		for (Entity r : entities)
		{
			tabPane.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
			String queryText = "<html><body>"+mapping.getQueryAsString().substring(0, mapping.getQueryAsString().indexOf("FOR RESOURCE"))+"<br>"+mapping.getQueryAsString().substring(mapping.getQueryAsString().indexOf("FOR RESOURCE"), mapping.getQueryAsString().indexOf("USING"))+"<br>"+mapping.getQueryAsString().substring(mapping.getQueryAsString().indexOf("USING"), mapping.getQueryAsString().length())+"</body></html>";
			JLabel querytext = new JLabel(queryText);
			querytext.setFont(new Font("Arial",Font.BOLD ,  15));
			querytext.setBackground(Color.WHITE);
			querytext.setOpaque(true);
			querytext.setSize(new Dimension(tabPane.getWidth(), 200));
			JPanel resourcePanel = new JPanel(new BorderLayout());
			
			
			resourcePanel.add(querytext, BorderLayout.NORTH);
			
			Visualizer engine = new Visualizer(r);
			engine.interpreteResource();
			resourcePanel.add(Box.createRigidArea(new Dimension(tabPane.getWidth(), 20)), BorderLayout.EAST);
			
			resourcePanel.add(engine.getCompletePanel(),BorderLayout.SOUTH);
			
			tabPane.addTab(r.getAlias(), resourcePanel);

		}
	}
	
}