
package tools.descartes.PAVO.types;

import java.util.List;
import org.jfree.data.statistics.DefaultBoxAndWhiskerCategoryDataset;
import tools.descartes.dql.models.mapping.domain.ConfidenceInterval;


public class BoxPlot  extends AbstractVisualizationType implements IVisualizationType{
	
	private DefaultBoxAndWhiskerCategoryDataset dataset = new DefaultBoxAndWhiskerCategoryDataset();
    

	public BoxPlot(){
	
	}
	
	public BoxPlot(String nameNeu, String nameXNeu, String nameYNeu, List<String> seriesNamesN, List<List<Double>> xValuesNeu, List<List<Double>> yvaluesNeu, List<List<ConfidenceInterval>> confidencesNeu){
		super(nameNeu, nameXNeu, nameYNeu, xValuesNeu, yvaluesNeu, seriesNamesN, confidencesNeu);
		for(int i = 0; i<seriesNamesN.size(); i++)
		{
			this.addCategory(this.getSeriesName().get(i), this.getyValues().get(i));
		}
	}
	
	public void addCategory(String seriesName, List<Double> values)
	{
		dataset.add(values, seriesName , ""); // Pro Kategorie eine Liste hinzu

	}
	
		
		/**
		 * @return the dataset
		 */
		public DefaultBoxAndWhiskerCategoryDataset getDataset() {
			return dataset;
		}

		/**
		 * @param dataset the dataset to set
		 */
		public void setDataset(DefaultBoxAndWhiskerCategoryDataset dataset) {
			this.dataset = dataset;
		}

		@Override
		public LineChart getLineChart() {
			LineChart line = new LineChart(this.getDiagramName(), this.getxAxisLabel(), this.getyAxisLabel(), this.getxValues(), this.getyValues(), this.getSeriesName(), this.getConfidences());
			return line;
		}

		@Override
		public BoxPlot getBoxPlot() {
			return this;
		}

		@Override
		public PieChart getPieChart() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public BarChart getBarChart() {
			BarChart bar = new BarChart(this.getDiagramName(), this.getxAxisLabel(), this.getyAxisLabel(), this.getSeriesName(),  this.getxValues(), this.getyValues(), this.getConfidences());
			return bar;
		}	
}