/**
 * This interface declares all different kinds of Diagrams, which can be shown by this libry
 * 
 * @author Maximilian Koenig
 */
package tools.descartes.PAVO.types;

import java.util.List;

import org.jfree.data.general.Dataset;

import tools.descartes.dql.models.mapping.domain.ConfidenceInterval;


public interface IVisualizationType {
	
	public  LineChart getLineChart();
	
	public  BoxPlot getBoxPlot();
	
	public  PieChart getPieChart();
	
	public  BarChart getBarChart();
	
	
	public String getDiagramName();
	public void setDiagramName(String diagramName);
	
	public abstract Dataset getDataset();
	
	public double getMax(List<Double> list);

	public double getMin(List<Double> list);

	public double getMean(List<Double> list);

	/**
	 * @return the xAxisLabel
	 */
	public String getxAxisLabel();

	/**
	 * @param xAxisLabel the xAxisLabel to set
	 */
	public void setxAxisLabel(String xAxisLabel);

	/**
	 * @return the yAxisLabel
	 */
	public String getyAxisLabel();

	/**
	 * @param yAxisLabel the yAxisLabel to set
	 */
	public void setyAxisLabel(String yAxisLabel);

	/**
	 * @return the yValues
	 */
	public List<List<Double>> getyValues();

	/**
	 * @param yValues the yValues to set
	 */
	public void setyValues(List<List<Double>> yValues);

	/**
	 * @return the xValues
	 */
	public List<List<Double>> getxValues();

	/**
	 * @param xValues the xValues to set
	 */
	public void setxValues(List<List<Double>> xValues);

	/**
	 * @return the seriesName
	 */
	public List<String> getSeriesName();

	/**
	 * @param seriesName the seriesName to set
	 */
	public void setSeriesName(List<String> seriesName);

	/**
	 * @return the confidences
	 */
	public List<List<ConfidenceInterval>> getConfidences();

	/**
	 * @param confidences the confidences to set
	 */
	public void setConfidences(List<List<ConfidenceInterval>> confidences);
	
	public String toString();
	
	public String getAnalysisResult();
	
	
	
	
	
	

	
	
}